
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>自绘CListCtrl防止闪烁的方法 / iVAN</title>

    <meta name="description" content="自绘CListCtrl防止闪烁的方法 自绘控件中经常会遇到闪烁的问题,主要原因是某个区域发生了重复性的绘制而导致的,而列表控件在自绘后闪烁原因是WM_ERASEBKGND消息所导致的.解决定办法可以将这个消息屏蔽掉,然后使用双缓存,在Windows 5.1版本以后可以使用LVS_EX_DOUBLEBUFFER样式,为了各个版本的兼容性我个人不建议使用这个样式,因此我们可以拦截WM_PAINT消息来使用我们自已创建的双缓存,具体看代码所示:  1.屏蔽WM_ERASEBKGND消息 BOOL CMyListCtrl::OnEraseB">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">自绘CListCtrl防止闪烁的方法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>自绘控件中经常会遇到闪烁的问题，主要原因是某个区域发生了重复性的绘制而导致的，而列表控件在自绘后闪烁原因是<strong>WM_ERASEBKGND</strong>消息所导致的。解决定办法可以将这个消息屏蔽掉，然后使用双缓存，在Windows 5.1版本以后可以使用<a><strong>LVS_EX_DOUBLEBUFFER</strong></a>样式，为了各个版本的兼容性我个人不建议使用这个样式，因此我们可以拦截WM_PAINT消息来使用我们自已创建的双缓存，具体看代码所示：</p>
<p> 1.屏蔽WM_ERASEBKGND消息<br />
<br />
<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg">BOOL CMyListCtrl::OnEraseBkgnd(CDC * pDC)  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkQmxvY2tTdGFydC5naWY=.jpg">{  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    return FALSE;  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkQmxvY2tFbmQuZ2lm.jpg">}</p>
<p>2.在WM_PAINT消息中使用自已的双缓存<br />
<br />
<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL05vbmUuZ2lm.jpg">void CMyListCtrl::OnPaint()  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkQmxvY2tTdGFydC5naWY=.jpg">{  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    CPaintDC dc(this);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    CRect rcClient,rcClip,rcHeader;  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    GetClientRect(&amp;rcClient);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    GetHeaderCtrl()-&gt;GetWindowRect(&amp;rcHeader);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    dc.GetClipBox(&amp;rcClip);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    CDC MemDC;  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    CBitmap MemBitmap, *pOldBitmap;  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemDC.CreateCompatibleDC(&amp;dc);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    int nMode = MemDC.SetMapMode(dc.GetMapMode());  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemBitmap.CreateCompatibleBitmap(&amp;dc,rcClient.Width(),rcClient.Height());  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    pOldBitmap = MemDC.SelectObject(&amp;MemBitmap);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemDC.FillSolidRect(&amp;rcClient,GetBkColor());  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    CRgn rgn;  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    rgn.CreateRectRgn(rcClip.left,rcClip.top,rcClip.right,rcClip.bottom);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemDC.SelectClipRgn(&amp;rgn);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    DefWindowProc(WM_PAINT,(WPARAM)MemDC.m_hDC,(LPARAM)0);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemDC.SelectClipRgn(NULL);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    if (rcClip.top &lt; rcHeader.Height())  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">        rcClip.top = rcHeader.Height();  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    dc.BitBlt(rcClip.left,rcClip.top,rcClip.Width(),rcClip.Height(),&amp;MemDC,rcClip.left,rcClip.top,SRCCOPY);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemDC.SetMapMode(nMode);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemDC.SelectObject(pOldBitmap);  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemDC.DeleteDC();  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    MemBitmap.DeleteObject();  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0luQmxvY2suZ2lm.jpg">    rgn.DeleteObject();  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmNwcGJsb2cuY29tL0ltYWdlcy9PdXRsaW5pbmdJbmRpY2F0b3JzL0V4cGFuZGVkQmxvY2tFbmQuZ2lm.jpg">}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 04:41:22</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%85%bc%e5%ae%b9%e6%80%a7/" title="兼容性">兼容性</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>自绘CListCtrl防止闪烁的方法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKNgvp.html" rel="bookmark">WPS演示里的文字设置成连续闪烁的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  WPS演示里的文字设置成连续闪烁的方法 1.首先选中要闪烁的文字,右击鼠标,点击&quot;自定义动画&quot;如图: 2.在&quot;添加效果&quot;中点击&quot;强调&quot;→再点击&quot;其他效果&quot;,如图: 3.在&quot;添加强调效果&quot;菜单中,选中&quot;闪动&quot;然后点击&quot;确定&quot;,如图: 4.再在设置栏中选择&quot;计时&quot;项目,如图: 5.在&quot;计时&quot;栏里将&quot;重复&quot;项,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPN9RDb.html" rel="bookmark">让PPT中对象闪烁的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在使用PowerPoint时,有时为了强调某个对象,需要让其在屏幕上闪烁几下.记得以前,我们常常需要将该对象复制多个后重叠在一起,然后再分别设置动画效果才可以实现.在PowerPoint2003中,已经提供了两种让对象闪烁的方法: 方法1:选定对象,单击&quot;自定义动画&quot;窗格中&quot;添加效果&quot;/&quot;进入&quot;/&quot;闪烁一次&quot;,即可为对象添加闪烁效果一次.但这种动画效果的缺点是动画效果演示完毕后,对象将会从屏幕上消失. 方法2:选定对象,单击&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNXl9p.html" rel="bookmark">vuejs在解析时出现闪烁的原因及防止闪烁的方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原因: 在使用vuejs.angularjs开发时,经常会遇见在如Chrome这类能够快速解析的浏览器上出现表达式({{ express }} ),或者是模块(div)的闪烁.对于这个问题由于JavaScript去操作DOM,都会等待DOM加载完成(DOM ready).对于vuejs.angularjs这些会在DOM ready完会才回去解析html view Template,所以对于Chrome这类快速的浏览器你会看见有闪烁的情况出现.而对于IE7,8这类解析稍慢的浏览器大部分情况下是不会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdm826z.html" rel="bookmark">php使用Jpgraph绘制饼状图的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php使用Jpgraph绘制饼状图的方法.分享给大家供大家参考.具体实现方法如下: &lt;?php include (&quot;src/jpgraph.php&quot;); include (&quot;src/jpgraph_pie.php&quot;); $data = array(19,23,34,38,45,67,71,78,85,87,90,96); $graph = new PieGraph(400,300); $graph-&gt;SetShadow(); $graph-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3YNWgp.html" rel="bookmark">【Visual C&plus;&plus;】Windows GDI贴图闪烁解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一般的windows 复杂的界面需要使用多层窗口而且要用贴图来美化,所以不可避免在窗口移动或者改变大小的时候出现闪烁. 先来谈谈闪烁产生的原因 原因一:如果熟悉显卡原理的话,调用GDI函数向屏幕输出的时候并不是立刻就显示在屏幕上只是写到了显存里,而显卡每隔一段时间把显存的内容输出到屏幕上,这就是刷新周期. 一般显卡的刷新周期是 1/80秒左右,具体数字可以自己设置的. 这样问题就来了,一般画图都是先画背景色,然后再把内容画上去,如果这两次操作不在同一个刷新周期内完成,那么给人的视觉感受就是,先看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Nz7e6KM.html" rel="bookmark">C&num;闪烁问题解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				解决|闪烁|问题 自从米格的仁兄向我推荐C#之后,偶就误入歧途的渐渐脱离了Java阵营.最近在写工具的时候,忽然发现了一个老生常谈的闪烁问题,要知道这样的问题在Java Swing里只要把DoubleBuffer设置为true基本上是不会发生的,但在C#上却怎么也搞不定,竟然连双缓冲都有问题,GDI+不会这么脆弱吧. 偶再一次被微软的花头给戏弄了,无奈只好踏上了漫漫搜索之路,也不知道搜了多少帖子,找了多少资料,基本上都是无功而返,更可气的是网上有些资料还骗人,偶试了试基本上都不行的,该闪的照样闪			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNPQep.html" rel="bookmark">MFC避免窗口闪烁的方法（OnEraseBkgnd） &period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在图形图象处理编程过程中,双缓冲是一种基本的技术.我们知道,如果窗体在响应WM_PAINT消息的时候要进行复杂的图形处理,那么窗体在重绘时由于过频的刷新而引起闪烁现象.解决这一问题的有效方法就是双缓冲技术.因为窗体在刷新时,总要有一个擦除原来图象的过程OnEraseBkgnd,它利用背景色填充窗体绘图区,然后在调用新的绘图代码进行重绘,这样一擦一写造成了图象颜色的反差.当WM_PAINT的响应很频繁的时候,这种反差也就越发明显.于是我们就看到了闪烁现象.我们会很自然的想到,避免背景色的填充是最直			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91v5kM.html" rel="bookmark">VC防止窗口和控件闪烁的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.将Invalidate()替换为InvalidateRect() Invalidate()会导致整个窗口的图象重画,需要的时间比较长,而InvalidateRect()仅仅重画Rect区域内的内容,所以所需时间会少一些.虫虫以前很懒,经常为一小块区域的重画就调用Invalidate(),不愿意自己去计算需要重画的Rect,但是事实是,如果你确实需要改善闪烁的情况,计算一个Rect所用的时间比起重画那些不需要重画的内容所需要的时间要少得多. 2.禁止系统搽除你的窗口 系统在需要重画窗口的时候会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP82q0p.html" rel="bookmark">解决显示器闪烁的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				现在朋友的显示器在经过摧残或者一些设置以后居然也有闪烁的问题,有时候画面抖动厉害,甚至还不如CRT显示器,这难道是显示器本身的质量问题? 那么液晶显示器闪烁的问题的解决方法是什么? 下面三联列举出一些解决方法,您的液晶显示器也有这样的毛病,可以参考解决,其实液晶显示器闪烁的一个最经典的诱因是相位抖动. 我们知道,目前常用的显示器信号输入有VGA和DVI两种,其中VGA是模拟信号输入,DVI则是数字信号(不考虑DVI-I和DVI-A). 而液晶显示器属于数字信号显示器,但为了兼容老的显示卡,很多液			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA72Kz.html" rel="bookmark" class="title">光猫与普通猫的区别</a>
					<div>
						  光猫是什么? 百度百科上专业的定义是这样的:所谓光猫,就是泛指将光以太信号转换成其它协议信号的收发设备.光猫是光modem的俗称,有着调制解调的作用.光猫也称为单端口光端机,是针对特殊用户环境而设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv6nVM.html" rel="bookmark" class="title">Adobe Flash CS4方块形状的动画特效制作</a>
					<div>
						在本教程中我们将会看到的是如何用adobe flash cs4制作一个方块形状的动画特效的制作过程! 1.新建一个flash Actionscript 3 大小为500×300px,背景黑色. 2.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR54Kb.html" rel="bookmark" class="title">PHP4和PHP5性能大对比</a>
					<div>
						PHP 4到今年年底PHP Group将不再对其进行支持了,所以为了让大家更有信心的转移到PHP 5平台上,我特别做了这个测试,看看我们PHP 4.x 是否真的性能比我们的PHP 5.x要好捏,测试结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJl4wM.html" rel="bookmark" class="title">利用ASP脚本制作异步装载的树形结构（一）（转）&mdash;&mdash;好东东！！</a>
					<div>
						脚本|异步 树形结构是描述层次数据的常见方法.本文介绍的树形结构生成程序主要由一个ASP页面.二个JavaScript函数构成.该树形结构是异步的,也就是说,节点数据仅在必要时才读取,而不是一次性全部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLxDap.html" rel="bookmark" class="title">用怎样的内容才能在搜索引擎优化中占据主动</a>
					<div>
						无论是作为SEOER,还是作为站长,相信我们都早已熟知了那句著名的&quot;内容为王&quot;的SEO经典俗语.这一语道尽了优化之中,内容占有的无可替代的重要作用,毕竟,搜索引擎最终就是要为用户服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEmndb.html" rel="bookmark" class="title">将Word 2010文档直接保存为PDF文件</a>
					<div>
						在Word 2007中,用户需要安装Microsoft Save as PDF加载项后才能将Word文档保存为PDF文件.而Word 2010具有直接 另存为PDF文件的功能,用户可以将Word 20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyV0xb.html" rel="bookmark" class="title">改进&period;NET应用程序的性能和可伸缩性（四）-SQL Server性能</a>
					<div>
						向上扩容和平面扩容 Optimize the application before scaling up or scaling out. 在你进行向上扩容和平面扩容前优化你的应用. 译注:你可以减少无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNmAmb.html" rel="bookmark" class="title">Spring声明式事务管理源码解读之事务提交</a>
					<div>
						在下面的文章中,我讲会多次提到第一篇文章,第一篇文章是:Spring声明式事务管 理源码解读之事务开始 如果要理解事务提交的话,理解事务开始是一个前提条件,所以请先看第一篇文章,再 来看这篇 如果你仔 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyGkeb.html" rel="bookmark" class="title">用CSS让DIV层水平居中</a>
					<div>
						一,用CSS让DIV层水平居中 对需要水平居中的DIV层添加以下属性: margin-left: auto; margin-right: auto; 这样在FF中已经居中了,可是在IE中看还是没有居中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNnrWM.html" rel="bookmark" class="title">Windows XP中更改管理员帐户名防黑客攻击</a>
					<div>
						  在运行Windows XP家庭版和专业版的计算机中,都存在一个内建的管理员账户,名称为&quot;Administrator&quot;,如此一来,假设有一黑客要攻击你的计算机,那他(也许是她)只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkG6lyp.html" rel="bookmark" class="title">大数据的那些事儿</a>
					<div>
						资源列表:   关系数据库管理系统(RDBMS)   框架   分布式编程   分布式文件系统   文件数据模型   Key -Map 数据模型   键-值数据模型   图形数据模型   NewSQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWWAjp.html" rel="bookmark" class="title">关于orale数据库的sql查询</a>
					<div>
						问题描述 关于orale数据库的sql查询 要查询以两个字段为查询条件的语句,设为a字段和b字段,条件值为c,d,结果想 查出a&gt;=c 和&lt;=c 并且b&gt;=d 和b&lt;=d 分别 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqjK8b.html" rel="bookmark" class="title">1-cmap错误急求，新手求指教</a>
					<div>
						问题描述 cmap错误急求,新手求指教 BOOL GetMapData(CMap mapfirstCMap &amp;mapnext );GetMapData(m_areaFirstList &amp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZRL4p.html" rel="bookmark" class="title">求解决-请大神们用c语言编写，并且用for循环，尽量不要太复杂，谢谢</a>
					<div>
						问题描述 请大神们用c语言编写,并且用for循环,尽量不要太复杂,谢谢 /**给定两个均不超过9的正整数a和n,要求编写程序求a+aa+aaa++?+aa?a(n个a)之和. 输入格式: 输入在一行中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmlk8M.html" rel="bookmark" class="title">外企55&period;6&percnt;赞成淘汰不需要的人</a>
					<div>
						(记者 薛冰 通讯员 小和) 记者从中南财经政法大学EMBA广东中心获悉,一项对该大学就读的EMBA学生进行的调查显示,今年有95%以上的企业还是会选择投资,外资企业的被调查者55.6%赞成淘汰不需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmJV6b.html" rel="bookmark" class="title">struct-复合结构体如何调用。如下怎样输出出生的年月日？下面的程序错在哪里？</a>
					<div>
						问题描述 复合结构体如何调用.如下怎样输出出生的年月日?下面的程序错在哪里? #include struct data { int year; int month; int day; }: struc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydqG8b.html" rel="bookmark" class="title">如何在Ubuntu上使用ADB备份Android数据</a>
					<div>
						备份 Android 系统上的应用数据.文本信息等等是非常乏味的,有时还很昂贵.电子市场的许多应用都承诺可以备份数据,但效果不佳或者需要付昂贵费用.你是否知道有一种更好的方法可以来做这件事,并且在你的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYAkyp.html" rel="bookmark" class="title">class-求指教下面程序的错误在哪</a>
					<div>
						问题描述 求指教下面程序的错误在哪 #include &quot;stdafx.h&quot; #include #include class complex { private: double x, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd8v4b.html" rel="bookmark" class="title">App制作干货：真旺云开发App之如何配置iOS发布？</a>
					<div>
						App制作完成之后,有许多人问,那么我们应该如何上架App呢?这里,通过企业移动App开发云平台 - 真旺云,打包App举个栗子. 首先,我们需要了解到,在真旺云平台制作好App之后,就需要进行iOS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmgeVb.html" rel="bookmark" class="title">A5 SEO诊断浅谈电子书制作流程</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 现在推广方式越来越多,电子书也早已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqkaqp.html" rel="bookmark" class="title">sql groupby-求解，SQL group by的一个问题。</a>
					<div>
						问题描述 求解,SQL group by的一个问题. --来自scott表. select deptno,ename from emp group by deptno 其中deptno,ename都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEP1KM.html" rel="bookmark" class="title">一个&period;NET的页面，点击页面中的按钮30S后页面就报错了，在数据库里执行存储过程需要45秒烦请高手指点一下</a>
					<div>
						问题描述 前台错误页面如下:web.config部分内容: 解决方案 解决方案二: 解决方案三:超时了.你可以设置页面请求超时时间.或者异步执行这个耗时的方法.解决方案四:优化查询,或者把超时时间增大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWEGnM.html" rel="bookmark" class="title">三星Galaxy Note2现锁屏漏洞 安全软件可防范</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   近日,有国外安全人员发现三星热销手机Galaxy No ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0ZNyM.html" rel="bookmark" class="title">经过1-3分钟的I&sol;O操作后，Session丢失！！何解？</a>
					<div>
						问题描述 我有一个页面A部署在服务器,需要大量的进行IO文件读写操作,因为要生成的文件较多,所以需要耗费1-3分钟才能完成操作.问题在于:当在页面A进行IO文件读写操作的同时,在另一主机登录系统,登录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0nAxp.html" rel="bookmark" class="title">Java布局管理器使用方法&lowbar;JSP编程</a>
					<div>
						很多初学者在用Java布局器自动布局画界面时,经常遇见不知道如何定义区域大小或按钮之间的距离等问题.我写过一篇&lt;实现JAVA手动布局中各个组件能随窗口变化的方法&gt;的文章,有读者反映算坐标不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWqG4z.html" rel="bookmark" class="title">javascript实现div的显示和隐藏的小例子&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;html&gt;&lt;head&gt;&lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8jrWb.html" rel="bookmark" class="title">童谣话历史：那些被证实的神奇预言</a>
					<div>
						导读:在中国古典文化中,大到&lt;周易&gt;&lt;推背图&gt;小至诗歌.童谣,我们都能够发现许多预言的痕迹.尽管我们从小就被告知,预言并不科学.然而随着被历史的一再证实,我们也一度相信古人或许 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlEZqp.html" rel="bookmark" class="title">C&num; 用RDP协议远程连接，怎么上传文件呀！</a>
					<div>
						问题描述 现在已经可以用rdp来登陆了!使用的以上控件实现,AxMsRdpClient9NotSafeForScripting问题:是否有办法在连接并登陆后,自动上传某个文件呢(或上传执行)?正常情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA6YOep.html" rel="bookmark" class="title">Racket 5&period;1&period;3发布 编程语言</a>
					<div>
						Racket是一种编程语言,适用于从脚本到http://www.aliyun.com/zixun/aggregation/13521.html&quot;&gt;应用程序开发的任务执行工具,包括图形用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWy2mM.html" rel="bookmark" class="title">围绕导购的领域暗潮涌动</a>
					<div>
						近日,行业内最暗潮涌动的领域应该是&quot;推荐购物.购物搜索.购物社区&quot;等等围绕导购的东西,就我的朋友,大概听过他们想法的,同时算是有实力的,都超过6家,其中有很多个大佬,有的还没开始就 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
